package com.huimv.face.controller;

import com.alibaba.fastjson.JSONArray;
import com.huimv.face.entity.Cameras;
import com.huimv.face.entity.SelectCamera;
import com.huimv.face.repo.CamerasRepository;
import com.huimv.face.repo.SelectCameraRepository;
import com.huimv.face.util.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import javax.servlet.http.HttpServletRequest;
import java.util.*;


@RestController
@RequestMapping("/api")
@CrossOrigin
public class SelectCameraController {

    @Autowired
    CamerasRepository camerasRepository;


    @Autowired
    private SelectCameraRepository selectCameraRepository;

    //对于陌生人有确认记录  需要直接操作数据库
    @RequestMapping("/ste_cameras")
    public Result getdate(HttpServletRequest request,
                          @RequestParam(name = "camera")  String[] cameras,
                          @RequestParam(name = "remark") String remark
    ) throws Exception {
        //直接查 ID =1  存储的时设备列表数据
        SelectCamera selectCamera  =selectCameraRepository.selectid1();
        String camer = new JSONArray(Arrays.asList(cameras)).toJSONString();
        List<String> list = Arrays.asList(cameras);
        //list转Array
        System.out.println("存储的相机数组为"+list);
        selectCamera.setCamera(camer);
        selectCamera.setRemark(remark);
        selectCameraRepository.save(selectCamera);
        return new Result(10000, "确认成功", selectCamera);
    }



    /**
     *
     * @param request
     * @return  列出所有相机
     * @throws Exception
     */
    @RequestMapping("/cameras")
    public Result getdate1(HttpServletRequest request
    ) throws Exception {
        List<Cameras> list = camerasRepository.findAll();
        List<Map> countlist = new ArrayList();
        for (Cameras cameras : list) {
            String location = cameras.getLocation();
            String camera_address = cameras.getCameraAddress();
            int deviceid = cameras.getId();
            Map map = new HashMap();
            map.put("location", location);
            map.put("camera_address", camera_address);
            map.put("deviceid", deviceid);
            countlist.add(map);
        }
        return new Result(10000, "查询成功", countlist);
    }



   /* //列出所有的摄像头,修改升级，直接查数据库
    @RequestMapping("/cameras")
    public Result getdate1(HttpServletRequest request,
                           @RequestParam(name = "_t") String _t
    ) throws Exception {
        String URL ="http://36.26.62.70:10081/api/cameras?_t="+_t;
        HttpClient httpClient = new HttpClient(URL);
        httpClient.setHttps(false);
        httpClient.get();
        String content = httpClient.getContent();
        JSONObject   jsonObject = JSONObject.parseObject(content);
        //取第一层中的data //json字符串
        System.out.println(_t);
        System.out.println(content);

        JSONArray listJa = jsonObject.getJSONArray("data");
        List<Map> countlist = new ArrayList();
        for (Object object : listJa) {
            Map<String, Object> maps = new HashMap<String, Object>();
            //对象全部装到map里
            maps.putAll((Map<? extends String, ?>) object);
            //获取时间
            String location = (String) maps.get("location");
            String camera_address = (String) maps.get("camera_address");
            String deviceid = (String) maps.get("deviceid");
            String  camera_id = deviceid.substring( deviceid.length()-1,  deviceid.length()-0);
            Map map = new HashMap( );
            map.put("location", location  );
            map.put("camera_id", camera_id  );
            map.put("camera_address", camera_address  );
            map.put("deviceid", deviceid  );
            countlist.add(map);
        }
        return new Result(10000, "查询成功" ,countlist);
    }*/

}
