package com.huimv.face.entity;

import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@Table(name = "cameras")
public class Cameras implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @Column(name = "id", nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    @Column(name = "type", nullable = false)
    private Integer type;

    @Column(name = "vendor", nullable = false)
    private Integer vendor;

    @Column(name = "device_id", nullable = false)
    private String deviceId;

    @Column(name = "switch_name")
    private String switchName;

    @Column(name = "switch_ip")
    private String switchIp;

    @Column(name = "create_time", nullable = false)
    private Long createTime;

    @Column(name = "update_time", nullable = false)
    private Long updateTime;

    @Column(name = "location", nullable = false)
    private String location;

    @Column(name = "gate", nullable = false)
    private Integer gate;

    @Column(name = "url", nullable = false)
    private String url;

    @Column(name = "threshold", nullable = false)
    private Double threshold;

    @Column(name = "quality", nullable = false)
    private Double quality;

    @Column(name = "groups", nullable = false)
    private String groups;

    @Column(name = "tag", nullable = false)
    private String tag;

    @Column(name = "longitude", nullable = false)
    private String longitude;

    @Column(name = "latitude", nullable = false)
    private String latitude;

    @Column(name = "mark", nullable = false)
    private String mark;

    @Column(name = "ip")
    private String ip;

    @Column(name = "port")
    private String port;

    @Column(name = "username")
    private String username;

    @Column(name = "password")
    private String password;

    @Column(name = "camera_address")
    private String cameraAddress;

    @Column(name = "human_temp_upper")
    private Double humanTempUpper;

    @Column(name = "human_temp_lower")
    private Double humanTempLower;

    @Column(name = "object_temp_lower")
    private Double objectTempLower;

    @Column(name = "send_smart_event_alert")
    private Integer sendSmartEventAlert;

    @Column(name = "from_email")
    private String fromEmail;

    @Column(name = "from_password")
    private String fromPassword;

    @Column(name = "to_email")
    private String toEmail;

    @Column(name = "table_info")
    private String tableInfo;

    @Column(name = "table_pos")
    private String tablePos;

    @Column(name = "roi")
    private String roi;


    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Integer getVendor() {
        return vendor;
    }

    public void setVendor(Integer vendor) {
        this.vendor = vendor;
    }

    public String getDeviceId() {
        return deviceId;
    }

    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }

    public String getSwitchName() {
        return switchName;
    }

    public void setSwitchName(String switchName) {
        this.switchName = switchName;
    }

    public String getSwitchIp() {
        return switchIp;
    }

    public void setSwitchIp(String switchIp) {
        this.switchIp = switchIp;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public Long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Long updateTime) {
        this.updateTime = updateTime;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public Integer getGate() {
        return gate;
    }

    public void setGate(Integer gate) {
        this.gate = gate;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Double getThreshold() {
        return threshold;
    }

    public void setThreshold(Double threshold) {
        this.threshold = threshold;
    }

    public Double getQuality() {
        return quality;
    }

    public void setQuality(Double quality) {
        this.quality = quality;
    }

    public String getGroups() {
        return groups;
    }

    public void setGroups(String groups) {
        this.groups = groups;
    }

    public String getTag() {
        return tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getMark() {
        return mark;
    }

    public void setMark(String mark) {
        this.mark = mark;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getPort() {
        return port;
    }

    public void setPort(String port) {
        this.port = port;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getCameraAddress() {
        return cameraAddress;
    }

    public void setCameraAddress(String cameraAddress) {
        this.cameraAddress = cameraAddress;
    }

    public Double getHumanTempUpper() {
        return humanTempUpper;
    }

    public void setHumanTempUpper(Double humanTempUpper) {
        this.humanTempUpper = humanTempUpper;
    }

    public Double getHumanTempLower() {
        return humanTempLower;
    }

    public void setHumanTempLower(Double humanTempLower) {
        this.humanTempLower = humanTempLower;
    }

    public Double getObjectTempLower() {
        return objectTempLower;
    }

    public void setObjectTempLower(Double objectTempLower) {
        this.objectTempLower = objectTempLower;
    }

    public Integer getSendSmartEventAlert() {
        return sendSmartEventAlert;
    }

    public void setSendSmartEventAlert(Integer sendSmartEventAlert) {
        this.sendSmartEventAlert = sendSmartEventAlert;
    }

    public String getFromEmail() {
        return fromEmail;
    }

    public void setFromEmail(String fromEmail) {
        this.fromEmail = fromEmail;
    }

    public String getFromPassword() {
        return fromPassword;
    }

    public void setFromPassword(String fromPassword) {
        this.fromPassword = fromPassword;
    }

    public String getToEmail() {
        return toEmail;
    }

    public void setToEmail(String toEmail) {
        this.toEmail = toEmail;
    }

    public String getTableInfo() {
        return tableInfo;
    }

    public void setTableInfo(String tableInfo) {
        this.tableInfo = tableInfo;
    }

    public String getTablePos() {
        return tablePos;
    }

    public void setTablePos(String tablePos) {
        this.tablePos = tablePos;
    }

    public String getRoi() {
        return roi;
    }

    public void setRoi(String roi) {
        this.roi = roi;
    }
}
